#region Includes...
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
#endregion

namespace SampleHookingApp
{
	public class MainForm : System.Windows.Forms.Form
	{
		#region Member Variables

		private System.Windows.Forms.Button buttonInstall;
		private System.Windows.Forms.Button buttonUninstall;
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.TextBox textBoxMessages;
		
		#endregion

		private Kennedy.ManagedHooks.KeyboardHook keyboardHook = null;

		public MainForm()
		{
			InitializeComponent();
	
			keyboardHook = new Kennedy.ManagedHooks.KeyboardHook();
			keyboardHook.KeyboardEvent += new Kennedy.ManagedHooks.KeyboardHook.KeyboardEventHandler(Hook_KeyboardEvent);
		}

		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (keyboardHook != null)
				{
					keyboardHook.Dispose();
					keyboardHook = null;
				}
			
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code
		// Required method for Designer support - do not modify
		// the contents of this method with the code editor.

		private void InitializeComponent()
		{
			this.buttonInstall = new System.Windows.Forms.Button();
			this.buttonUninstall = new System.Windows.Forms.Button();
			this.textBoxMessages = new System.Windows.Forms.TextBox();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.SuspendLayout();
			// 
			// buttonInstall
			// 
			this.buttonInstall.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.buttonInstall.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.buttonInstall.Location = new System.Drawing.Point(8, 8);
			this.buttonInstall.Name = "buttonInstall";
			this.buttonInstall.Size = new System.Drawing.Size(312, 32);
			this.buttonInstall.TabIndex = 0;
			this.buttonInstall.Text = "&Install Mouse and Keyboard Hooks";
			this.buttonInstall.Click += new System.EventHandler(this.buttonInstall_Click);
			// 
			// buttonUninstall
			// 
			this.buttonUninstall.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.buttonUninstall.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.buttonUninstall.Location = new System.Drawing.Point(8, 44);
			this.buttonUninstall.Name = "buttonUninstall";
			this.buttonUninstall.Size = new System.Drawing.Size(312, 32);
			this.buttonUninstall.TabIndex = 1;
			this.buttonUninstall.Text = "&Uninstall Mouse and Keyboard Hooks";
			this.buttonUninstall.Click += new System.EventHandler(this.buttonUninstall_Click);
			// 
			// textBoxMessages
			// 
			this.textBoxMessages.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.textBoxMessages.BackColor = System.Drawing.Color.White;
			this.textBoxMessages.Location = new System.Drawing.Point(0, 84);
			this.textBoxMessages.Multiline = true;
			this.textBoxMessages.Name = "textBoxMessages";
			this.textBoxMessages.ReadOnly = true;
			this.textBoxMessages.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.textBoxMessages.Size = new System.Drawing.Size(328, 320);
			this.textBoxMessages.TabIndex = 2;
			this.textBoxMessages.TabStop = false;
			this.textBoxMessages.Text = "";
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 404);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Size = new System.Drawing.Size(328, 22);
			this.statusBar1.TabIndex = 3;
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(328, 426);
			this.Controls.Add(this.statusBar1);
			this.Controls.Add(this.textBoxMessages);
			this.Controls.Add(this.buttonUninstall);
			this.Controls.Add(this.buttonInstall);
			this.Name = "MainForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "System Hook Test Application";
			this.ResumeLayout(false);

		}
		#endregion

		#region Main Method
		// The main entry point for the application.

		[STAThread]
		static void Main() 
		{

			// Give our app an XP theme look.
			Application.EnableVisualStyles();
			Application.DoEvents();

			Application.Run(new MainForm());
		}

		#endregion

		private void buttonInstall_Click(object sender, System.EventArgs e)
		{
			string msg = "Adding keyboard hook.\r\n";
			textBoxMessages.Text = msg + textBoxMessages.Text;

			//  Install Hook
			keyboardHook.InstallHook();
		}

		private void buttonUninstall_Click(object sender, System.EventArgs e)
		{
			string msg = "Keyboard hook removed.\r\n";
			textBoxMessages.Text = msg + textBoxMessages.Text;

			//  Remove Hook
			keyboardHook.UninstallHook();
		}

		private void Hook_KeyboardEvent(Kennedy.ManagedHooks.KeyboardEvents kEvent, Keys key)
		{
			string msg = string.Format("Keyboard event: {0}: {1}.\r\n", kEvent.ToString(), key);
			textBoxMessages.Text = msg + textBoxMessages.Text;
		}

	}
}
